#!/usr/bin/env bash

# Copyright © 2020 Amazon Web Services
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# from tests/aws/ goes up to the tests dir.
cd ../../

# Install venv for python3
which apt-get && sudo apt-get install -y python3 python3-pip python3-venv || echo "Not Ubuntu, skipping"
which yum && sudo yum install -y python3 python3-pip python3-venv || echo "Not RHEL, skipping"

echo "Requires Python 3.9"
python3 --version
python3 -m venv env
source env/bin/activate
python3 -m pip install --upgrade pip
python3 -m pip install -r requirements.txt

export AWS_POLICY_SERVICE_URL=$AWS_BASE_URL
export DATA_PARTITION=int-test-policy
# Default polling period is 120s (if polling is enabled)
# AWS max_delay_seconds: 12
export BUNDLE_PAUSE=24
export ENTITLEMENTS_BASE_URL=$AWS_BASE_URL
export LEGAL_BASE_URL=$AWS_BASE_URL
export OPA_URL=$AWS_BASE_URL
export CLOUD_PROVIDER="aws"

echo AWS_POLICY_SERVICE_URL $AWS_POLICY_SERVICE_URL
echo DATA_PARTITION $DATA_PARTITION
echo BUNDLE_PAUSE $BUNDLE_PAUSE
echo ENTITLEMENTS_BASE_URL $ENTITLEMENTS_BASE_URL
echo LEGAL_BASE_URL $LEGAL_BASE_URL
echo OPA_URL $OPA_URL
echo CLOUD_PROVIDER $CLOUD_PROVIDER
svctoken=$(python3 tests/aws/aws_jwt_client.py)

python3 -m pytest -s -v --token=$svctoken --service_url=$AWS_POLICY_SERVICE_URL --data_partition=$DATA_PARTITION --bundle_pause=$BUNDLE_PAUSE
