# Load testing of Policy Service via locust

## Needs the following env variable to be set:
* DATA_PARTITION
* TOKEN
* SERVICE_URL

## Optionally the test supports an environment variable:
* TARGET_DATA_PARTITION - the DATA_PARTITION of where policy is running this is used in templates and for API path
  This is intended to only be used when you are testing from one data_partition and the service is in another.
  If not provided, DATA_PARTITION will be used.
  Please note not all functions will work in policy if your path data_partition is different from the request header data_partition_id

## expected to run in gitlab pipeline
loadtest.yml

## Tests currently in loadtest
* /health
* /policies/osdu/partition/<target_data_partition>/dataauthz.rego
* /policies/osdu/partition/<target_data_partition>/search2.rego
* /evaluate
* /translate

## Evaluate Notes:
* /evaluate uses a template in ../frontend/admincli/tests/translate_data.json and
* requires search2.rego policy to be already loaded into data_partition

## Artifacts:
* stats*exceptions.csv
* stats*failures.csv
* stats*stats.csv
* stats*stats_history.csv

# TODO:
* add policy compile
* add search and storage
